#ifndef _TIM_CONV_C_H_
#define _TIM_CONV_C_H_

#include "tim_comm_c.h"
#include "tim_msg_c.h"


extern "C"
{
	TIM_DECL TIMConversationHandle	CreateConversation();
	TIM_DECL void					DestroyConversation(TIMConversationHandle handle);

	TIM_DECL void SendMsg(TIMConversationHandle conv_handle, TIMMessageHandle msg_handle, TIMCommCB *callback);
	TIM_DECL int  SaveMsg(TIMConversationHandle conv_handle, TIMMessageHandle msg_handle, const char* sender, bool readed);
	TIM_DECL void GetMsgs(TIMConversationHandle conv_handle, int count, TIMMessageHandle last_msg, TIMGetMsgCB * callback);
	TIM_DECL void SetReadMsg(TIMConversationHandle conv_handle, TIMMessageHandle last_read_msg);
 	TIM_DECL uint64_t GetUnreadMessageNum(TIMConversationHandle conv_handle);

	TIM_DECL int GetConversationPeer(TIMConversationHandle conv_handle, char* buf, uint32_t* len);
	TIM_DECL const TIMConversationType GetConversationType(TIMConversationHandle conv_handle);

	TIM_DECL void SetConversationPeer(TIMConversationHandle conv_handle, const char* peer);
	TIM_DECL void SetConversationType(TIMConversationHandle conv_handle, const TIMConversationType type);

};



#endif