#ifndef _TIM_FRIEND_C_H_
#define _TIM_FRIEND_C_H_

#include "tim_comm_c.h"
extern "C"
{
	typedef enum _E_TIMFriendAllowType
	{
		TIM_FRIEND_ALLOW_ANY                    = 0,//ͬκûӺ
		TIM_FRIEND_DENY_ANY                     = 1,//ܾκ˼Ӻ
		TIM_FRIEND_NEED_CONFIRM                 = 2,//Ҫ֤
	}E_TIMFriendAllowType;

	typedef enum _E_TIMFriendResponseType
	{
	    TIM_FRIEND_RESPONSE_AGREE				= 0,//ͬӺѣѣ
		TIM_FRIEND_RESPONSE_AGREE_AND_ADD		= 1,//ͬӺѲӶԷΪѣ˫ѣ
		TIM_FRIEND_RESPONSE_REJECT				= 2,//ܾԷ
	}E_TIMFriendResponseType;

	typedef enum _E_TIMProfileFlag
	{
		TIM_PROFILE_FLAG_NONE			= 0x00,
		TIM_PROFILE_FLAG_NICK			= 0x01, //ǳ
		TIM_PROFILE_FLAG_ALLOW_TYPE		= 0x01 << 1, //֤ʽ
		TIM_PROFILE_FLAG_FACE_URL       = 0x01 << 2, //ͷ
		TIM_PROFILE_FLAG_REMARK         = 0x01 << 3, //ѱע
	}TIMProfileFlag;

	typedef enum _E_TIMPendencyGetType
	{
		TIM_PENDENCY_GET_COME_IN                    = 1, //˷ҵ
		TIM_PENDENCY_GET_SEND_OUT                   = 2, //ҷ˵
		TIM_PENDENCY_GET_BOTH                       = 3, //˷ҵ  ҷ˵
	}TIMPendencyGetType;

	typedef enum  
	{
		TIM_PAGE_DIRECTION_UP_TYPE		= 1, //Ϸҳ
		TIM_PAGE_DIRECTION_DOWN_TYPE	= 2, //·ҳ
	}TIMPageDirectionType;

	typedef enum  
	{
		TIM_FutureTypePendencyComeIn = 0x01, // յδ
		TIM_FutureTypePendencySendOut = 0x02, //ȥδ
		TIM_FutureTypeRecommend = 0x04, //Ƽ
		TIM_FutureTypeDeccide = 0x08, //Ѿ
	}TIMFutureFriendType;

#define TIM_FRIEND_STATUS_SUCC								0//ɹ
#define TIM_ADD_FRIEND_STATUS_IN_SELF_BLACK_LIST			30515//ӺʱЧӺԼĺ
#define TIM_ADD_FRIEND_STATUS_FRIEND_SIDE_FORBID_ADD		30516//ӺʱЧӺΪֹӺ
#define TIM_ADD_FRIEND_STATUS_SELF_FRIEND_FULL				30519//ӺʱЧ
#define TIM_ADD_FRIEND_STATUS_ALREADY_FRIEND				30520//ӺʱЧѾǺ
#define TIM_ADD_FRIEND_STATUS_IN_OTHER_SIDE_BLACK_LIST		30525//ӺʱЧѱӺΪ
#define TIM_ADD_FRIEND_STATUS_PENDING						30539//ӺʱЧȴͬ
#define TIM_DEL_FRIEND_STATUS_NO_FRIEND						31704//ɾʱЧɾʱԷǺ
#define TIM_RESPONSE_FRIEND_STATUS_NO_REQ                   30614//ӦʱЧԷû
#define TIM_RESPONSE_FRIEND_STATUS_SELF_FRIEND_FULL			30615//ӦʱЧԼĺ
#define TIM_RESPONSE_FRIEND_STATUS_FRIEND_EXIST				30617//ӦʱЧѾ
#define TIM_RESPONSE_FRIEND_STATUS_OTHER_SIDE_FRIEND_FULL   30630//ӦʱЧԷ
#define TIM_ADD_BLACKLIST_FRIEND_STATUS_IN_BLACK_LIST		31307//ӺЧѾں
#define TIM_DEL_BLACKLIST_FRIEND_STATUS_NOT_IN_BLACK_LIST	31503//ɾЧûں

	typedef void* TIMProfileCustomInfoHandle;
	TIM_DECL TIMProfileCustomInfoHandle CreateProfileCustomInfoHandle();
	TIM_DECL void DestroyProfileCustomInfoHandle(TIMProfileCustomInfoHandle handle);
	TIM_DECL TIMProfileCustomInfoHandle CloneProfileCustomInfoHandle(TIMProfileCustomInfoHandle handle);
	//value 256ֽ key8ֽ
	TIM_DECL bool AddProfileCustomInfo(TIMProfileCustomInfoHandle handle, const char* key, uint32_t key_len, const char* value, uint32_t value_len);
	TIM_DECL uint32_t GetProfileCustomInfoNum(TIMProfileCustomInfoHandle handle);
	TIM_DECL int GetProfileCustomInfo(TIMProfileCustomInfoHandle handle, char* key, uint32_t key_len, char* value, uint32_t* value_len);
	TIM_DECL int GetProfileCustomInfoByIndex(TIMProfileCustomInfoHandle handle, int index, char* key, uint32_t* key_len, char* value, uint32_t* value_len);

	typedef void* TIMFriendResultHandle;
	TIM_DECL int GetID4FriendResultHandle(TIMFriendResultHandle handle, char* id, uint32_t* len);
	TIM_DECL uint64_t GetResult4FriendResultHandle(TIMFriendResultHandle handle);

	//û
	typedef void* TIMProfileHandle;
	TIM_DECL TIMProfileHandle CreateProfileHandle();
	TIM_DECL void DestroyProfileHandle(TIMProfileHandle handle);
	TIM_DECL TIMProfileHandle CloneProfileHandle(TIMProfileHandle handle);
	//ûidentifier
	TIM_DECL void	SetID4ProfileHandle(TIMProfileHandle handle, char* id);
	TIM_DECL int	GetID4ProfileHandle(TIMProfileHandle handle, char* id_buf, uint32_t* len);
	//ûǳ 96ֽ
	TIM_DECL void SetNickName4ProfileHandle(TIMProfileHandle handle, char* nick_name, uint32_t len);
	TIM_DECL int	GetNickName4ProfileHandle(TIMProfileHandle handle, char* buf, uint32_t* len);
	//֤ʽ
	TIM_DECL void	SetAllowType4ProfileHandle(TIMProfileHandle handle, E_TIMFriendAllowType type);
	TIM_DECL E_TIMFriendAllowType	GetAllowType4ProfileHandle(TIMProfileHandle handle);
	//ûע 120ֽ
	TIM_DECL void	SetRemark4ProfileHandle(TIMProfileHandle handle, char* remark, uint32_t len);
	TIM_DECL int	GetRemark4ProfileHandle(TIMProfileHandle handle, char* remark, uint32_t* len);
	//Ӻwording 120ֽ
	TIM_DECL void	SetAddWord4ProfileHandle(TIMProfileHandle handle, char* word, uint32_t len);
	TIM_DECL int	GetAddWord4ProfileHandle(TIMProfileHandle handle, char* word, uint32_t* len);
	TIM_DECL void	SetAddSource4ProfileHandle(TIMProfileHandle handle, char* source);
	TIM_DECL int	GetAddSource4ProfileHandle(TIMProfileHandle handle, char* source, uint32_t* len);
	TIM_DECL void	SetFaceURL4ProfileHandle(TIMProfileHandle handle, char* faceurl, uint32_t len);
	TIM_DECL int	GetFaceURL4ProfileHandle(TIMProfileHandle handle, char* faceurl, uint32_t* len);

	TIM_DECL int GetResponse4ProfileHandle(TIMProfileHandle handle, char* response, uint32_t* len);
	TIM_DECL uint64_t GetResult4ProfileHandle(TIMProfileHandle handle);


	typedef void* TIMSelfProfileHandle;
	TIM_DECL TIMSelfProfileHandle CloneSelfProfileHandle(TIMSelfProfileHandle handle);
	TIM_DECL void DestroySelfProfileHandle(TIMSelfProfileHandle handle);
	TIM_DECL int GetNickName4SlefProfileHandle(TIMSelfProfileHandle handle, char* buf, uint32_t* len);
	TIM_DECL E_TIMFriendAllowType GetAllowType4SlefProfileHandle(TIMSelfProfileHandle handle);

	typedef void* TIMFriendProfileHandle;
	TIM_DECL TIMFriendProfileHandle CloneFriendProfileHandle(TIMFriendProfileHandle handle);
	TIM_DECL void DestroyFriendProfileHandle(TIMFriendProfileHandle handle);
	TIM_DECL int GetID4FriendProfileHandle(TIMFriendProfileHandle handle, char* id, uint32_t* len);
	TIM_DECL int GetNickName4FriendProfileHandle(TIMFriendProfileHandle handle, char* buf, uint32_t* len);
	TIM_DECL int GetRemark4FriendProfileHandle(TIMFriendProfileHandle handle, char* remark, uint32_t* len);
	TIM_DECL E_TIMFriendAllowType GetAllowType4FriendProfileHandle(TIMFriendProfileHandle handle);
	TIM_DECL int GetFaceURL4FriendProfileHandle(TIMFriendProfileHandle handle, char* faceurl, uint32_t* len);
	TIM_DECL TIMProfileCustomInfoHandle GetCustomInfo4FriendProfileHandle(TIMFriendProfileHandle handle);

	typedef void* TIMFriendListElemHandle;
	TIM_DECL TIMFriendListElemHandle CloneFriendListElemHandle(TIMFriendListElemHandle handle);
	TIM_DECL void DestroyFriendListElemHandle(TIMFriendListElemHandle handle);
	TIM_DECL int GetID4FriendListElemHandle(TIMFriendListElemHandle handle, char* id, uint32_t* len);
	TIM_DECL int GetNickName4FriendListElemHandle(TIMFriendListElemHandle handle, char* buf, uint32_t* len);
	TIM_DECL int GetRemark4FriendListElemHandle(TIMFriendListElemHandle handle, char* remark, uint32_t* len);
	TIM_DECL int GetFaceURL4FriendListElemHandle(TIMFriendListElemHandle handle, char* face_url, uint32_t* len);

	typedef void* TIMAddFriendHandle;
	TIM_DECL TIMAddFriendHandle CreateAddFriendHandle();
	TIM_DECL void DestroyAddFriendHandle(TIMAddFriendHandle handle);
	TIM_DECL void SetID4AddFriendHandle(TIMAddFriendHandle handle, char* id);
	//ûǳ 96ֽ
	TIM_DECL void SetNickName4AddFriendHandle(TIMAddFriendHandle handle, char* nick_name, uint32_t len);
	//ѱע 120ֽ
	TIM_DECL void SetRemark4AddFriendHandle(TIMAddFriendHandle handle, char* remark, uint32_t len);
	//Դ
	TIM_DECL void SetAddSource4AddFriendHandle(TIMAddFriendHandle handle, char* source);
	//Ӻwording
	TIM_DECL void SetAddWord4AddFriendHandle(TIMAddFriendHandle handle, char* word, uint32_t len);

	typedef void* TIMFriendResponseHandle;
	TIM_DECL TIMFriendResponseHandle CreateFriendResponseHandle();
	TIM_DECL void DestroyFriendResponseHandle(TIMFriendResponseHandle handle);
	//ûID
	TIM_DECL void SetID4FriendResponseHandle(TIMFriendResponseHandle handle, char* id);
	//Ӧ
	TIM_DECL void SetResponseType4FriendResponseHandle(TIMFriendResponseHandle handle, E_TIMFriendResponseType type);

	typedef void* TIMSetProfileOptionHandle;
	TIM_DECL TIMSetProfileOptionHandle CreateSetProfileOptionHandle();
	TIM_DECL void DestroySetProfileOptionHandle(TIMSetProfileOptionHandle handle);
	TIM_DECL void SetFlag4SetProfileOptionHandle(TIMSetProfileOptionHandle handle, TIMProfileFlag flag);
	TIM_DECL void SetNick4SetProfileOptionHandle(TIMSetProfileOptionHandle handle, char* nick, uint32_t len);
	TIM_DECL void SetAllowType4SetProfileOptionHandle(TIMSetProfileOptionHandle handle, E_TIMFriendAllowType type);
	TIM_DECL void SetFaceURL4SetProfileOptionHandle(TIMSetProfileOptionHandle handle, char* faceurl, uint32_t len);
	TIM_DECL void SetCustomInfo4SetProfileOptionHandle(TIMSetProfileOptionHandle handle, TIMProfileCustomInfoHandle custom_info);

	typedef void* TIMGetProfileOptionHandle;
	TIM_DECL TIMGetProfileOptionHandle CreateGetProfileOptionHandle();
	TIM_DECL void DestroyGetProfileOptionHandle(TIMGetProfileOptionHandle handle);
	TIM_DECL void SetFlag4GetProfileOptionHandle(TIMGetProfileOptionHandle handle, TIMProfileFlag type);
	TIM_DECL void SetCustomInfo4GetProfileOptionHandle(TIMGetProfileOptionHandle handle, TIMProfileCustomInfoHandle custom_info);

	typedef void* TIMFriendMetaInfoHandle;
	TIM_DECL TIMFriendMetaInfoHandle CreateFriendMetaInfoHandle();
	TIM_DECL void DestroyFriendMetaInfoHandle(TIMFriendMetaInfoHandle handle);
	TIM_DECL TIMFriendMetaInfoHandle CloneFriendMetaInfoHandle(TIMFriendMetaInfoHandle handle);
	//ʱҪ棬´ȡʱ룬ʹ
	TIM_DECL void SetTimestamp4FriendMetaInfoHandle(TIMFriendMetaInfoHandle handle, const uint64_t timestamp);
	TIM_DECL uint64_t GetTimestamp4FriendMetaInfoHandle(TIMFriendMetaInfoHandle handle);
	//кţҪ棬´ȡʱ룬ʹ
	TIM_DECL void SetInfoSeq4FriendMetaInfoHandle(TIMFriendMetaInfoHandle handle, const uint64_t info_seq);
	TIM_DECL uint64_t GetInfoSeq4FriendMetaInfoHandle(TIMFriendMetaInfoHandle handle);
	//ҳϢ豣棬Ϊ0ʱ0ʱٴȡһȡʱ0
	TIM_DECL void SetNextSeq4FriendMetaInfoHandle(TIMFriendMetaInfoHandle handle, const uint64_t next_seq);
	TIM_DECL uint64_t GetNextSeq4FriendMetaInfoHandle(TIMFriendMetaInfoHandle handle);
	//ǣΪTRUEʱҪtimestamp, infoSeq, nextSeqΪ0ͻ˴洢ȡ
	TIM_DECL void SetRecover4FriendMetaInfoHandle(TIMFriendMetaInfoHandle handle, const bool recover);
	TIM_DECL bool GetRecover4FriendMetaInfoHandle(TIMFriendMetaInfoHandle handle);
	
	//δԪϢ
	typedef void* TIMFriendPendencyMetaHandle;
	TIM_DECL TIMFriendPendencyMetaHandle CreateFriendPendencyMetaHandle();
	TIM_DECL void DestroyFriendPendencyMetaHandle(TIMFriendPendencyMetaHandle handle);
	/**
	*кţδбк
	*ͻ˱seqδбʱserverصseq
	*seqserverµģ򲻷
	*/
	TIM_DECL void SetSeq4FriendPendencyMetaHandle(TIMFriendPendencyMetaHandle handle, const uint64_t seq);
	TIM_DECL uint64_t GetSeq4FriendPendencyMetaHandle(TIMFriendPendencyMetaHandle handle);
	/**
	* ҳʱֻҳserver0ʱʾûиݣһ0
	*    رעǣserverصseqseqͬҳУҪʹÿͻԭʼseqֱϣܸ±seq
	*/
	TIM_DECL void SetTimestamp4FriendPendencyMetaHandle(TIMFriendPendencyMetaHandle handle, const uint64_t timestamp);
	TIM_DECL uint64_t GetTimestamp4FriendPendencyMetaHandle(TIMFriendPendencyMetaHandle handle);

	/**
	* ÿҳʱЧֵserverɸҪػ٣Ϊı־
	*/
	TIM_DECL void SetNumPerPage4FriendPendencyMetaHandle(TIMFriendPendencyMetaHandle handle, const uint64_t num_per_page);
	TIM_DECL uint64_t GetNumPerPage4FriendPendencyMetaHandle(TIMFriendPendencyMetaHandle handle);

	/**
	* δδЧ
	*/
	TIM_DECL uint64_t GetUnreadCnt4FriendPendencyMetaHandle(TIMFriendPendencyMetaHandle handle);
	

	//δ
	typedef void* TIMFriendPendencyItemHandle;
	TIM_DECL TIMFriendPendencyItemHandle CloneFriendPendencyItemHandle(TIMFriendPendencyItemHandle handle);
	TIM_DECL void DestroyFriendPendencyItemHandle(TIMFriendPendencyItemHandle handle);
	TIM_DECL int GetID4FriendPendencyItemHandle(TIMFriendPendencyItemHandle handle, char* id, uint32_t* id_len);
	//ȡʱ
	TIM_DECL uint64_t GetAddTime4FriendPendencyItemHandle(TIMFriendPendencyItemHandle handle);
	//ȡԴ
	TIM_DECL int GetAddSource4FriendPendencyItemHandle(TIMFriendPendencyItemHandle handle, char* add_source, uint32_t* len);
	//ȡӺѸ
	TIM_DECL int GetAddWord4FriendPendencyItemHandle(TIMFriendPendencyItemHandle handle, char* add_word, uint32_t* len);
	//ȡǳ
	TIM_DECL int GetNick4FriendPendencyItemHandle(TIMFriendPendencyItemHandle handle, char* nick, uint32_t* len);
	//ȡδ
	TIM_DECL TIMPendencyGetType GetPendencyTypeFriendPendencyItemHandle(TIMFriendPendencyItemHandle handle);

	typedef void* TIMFriendFutureMetaHandle;
	TIM_DECL TIMFriendFutureMetaHandle CreateFriendFutureMetaHandle();
	TIM_DECL void DestroyFriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	TIM_DECL TIMFriendFutureMetaHandle CloneFriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	// req info
	TIM_DECL void SetDirection4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle, TIMPageDirectionType type);
	TIM_DECL void SetReqNum4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle, uint64_t reqnum);

	// for req and resp
	TIM_DECL void SetTimeStamp4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle, uint64_t timestamp);
	TIM_DECL uint64_t GetTimeStamp4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	TIM_DECL void SetPendencySequence4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle, uint64_t seq);
	TIM_DECL uint64_t GetPendencySequence4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	TIM_DECL void SetRecommendSequence4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle, uint64_t seq);
	TIM_DECL uint64_t GetRecommendSequence4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	TIM_DECL void SetDecideSequence4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle, uint64_t seq);
	TIM_DECL uint64_t GetDecideSequence4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	TIM_DECL void SetPendencyUnReadCnt4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle, uint64_t cnt);
	TIM_DECL uint64_t GetPendencyUnReadCnt4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	TIM_DECL void SetRecommendUnReadCnt4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle, uint64_t cnt);
	TIM_DECL uint64_t GetRecommendUnReadCnt4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	// just for response
	TIM_DECL uint64_t GetCurrentPendencyTimestamp4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	TIM_DECL uint64_t GetCurrentRecommendTimestamp4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);
	TIM_DECL uint64_t GetCurrentDecideTimestamp4FriendFutureMetaHandle(TIMFriendFutureMetaHandle handle);

	typedef void* TIMFriendRecommendTagsHandle;
	TIM_DECL uint32_t GetTagsNum4FriendRecommendTagsHandle(TIMFriendRecommendTagsHandle handle);
	TIM_DECL int GetTag4FriendRecommendTagsHandle(TIMFriendRecommendTagsHandle handle, char* key, uint32_t key_len, char* value, uint32_t* value_len);
	TIM_DECL int GetTagByIndex4FriendRecommendTagsHandle(TIMFriendRecommendTagsHandle handle, int index, char* key, uint32_t* key_len, char* value, uint32_t* value_len);

	typedef void* TIMFriendFutureItemHandle;
	TIM_DECL TIMFriendFutureItemHandle CloneFriendFutureItemHandle(TIMFriendFutureItemHandle handle);
	TIM_DECL void DestroyFriendFutureItemHandle(TIMFriendFutureItemHandle handle);
	TIM_DECL TIMFutureFriendType GetType4FriendFutureItemHandle(TIMFriendFutureItemHandle handle);
	//id
	TIM_DECL int GetID4FriendFutureItemHandle(TIMFriendFutureItemHandle handle, char* id, uint32_t* len);
	// //handledestroy
	TIM_DECL TIMProfileHandle GetProfileHandle4FriendFutureItemHandle(TIMFriendFutureItemHandle handle);
	//ʱ
	TIM_DECL uint64_t GetAddTime4FriendFutureItemHandle(TIMFriendFutureItemHandle handle);
	//ԴδЧ
	TIM_DECL int GetAddSource4FriendFutureItemHandle(TIMFriendFutureItemHandle handle, char* source, uint32_t* len);
	//ӺѸԣδЧ
	TIM_DECL int GetAddWording4FriendFutureItemHandle(TIMFriendFutureItemHandle handle, char* wording, uint32_t* len);
	TIM_DECL TIMFriendRecommendTagsHandle GetRecommendTagsHandle44FriendFutureItemHandle(TIMFriendFutureItemHandle handle);

	// callback
	typedef void (*CBFriendshipActionCallbackOnSuccess) (TIMProfileHandle* handles, uint32_t num, void* data);
	typedef void (*CBFriendshipActionCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMFriendshipActionCallback
	{
		CBFriendshipActionCallbackOnSuccess OnSuccess;
		CBFriendshipActionCallbackOnError OnError;
		void* data;
	}TIMFriendshipActionCB;

	typedef void (*CBGetSelfProfileCallbackOnSuccess) (TIMSelfProfileHandle* handles, uint32_t num, void* data);
	typedef void (*CBGetSelfProfileCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMGetSelfProfileCallback
	{
		CBGetSelfProfileCallbackOnSuccess OnSuccess;
		CBGetSelfProfileCallbackOnError OnError;
		void* data;
	}TIMGetSelfProfileCallback;

	typedef void (*CBGetFriendProfileCallbackOnSuccess) (TIMFriendProfileHandle* handles, uint32_t num, void* data);
	typedef void (*CBGetFriendProfileCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMGetFriendProfileCallback
	{
		CBGetFriendProfileCallbackOnSuccess OnSuccess;
		CBGetFriendProfileCallbackOnError OnError;
		void* data;
	}TIMGetFriendProfileCallback;

	typedef void (*CBGetFriendListCallbackOnSuccess) (TIMFriendListElemHandle* handles, uint32_t num, void* data);
	typedef void (*CBGetFriendListCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMGetFriendListCallback
	{
		CBGetFriendListCallbackOnSuccess OnSuccess;
		CBGetFriendListCallbackOnError OnError;
		void* data;
	}TIMGetFriendListCallback;

	typedef void (*CBGetFriendListV2CallbackOnSuccess) (TIMFriendMetaInfoHandle meta_handle, TIMFriendListElemHandle* handles, uint32_t num, void* data);
	typedef void (*CBGetFriendListV2CallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMGetFriendListV2Callback
	{
		CBGetFriendListV2CallbackOnSuccess OnSuccess;
		CBGetFriendListV2CallbackOnError OnError;
		void* data;
	}TIMGetFriendListV2Callback;

	typedef void (*CBAddFriendCallbackOnSuccess) (TIMFriendResultHandle* handles, uint32_t num, void* data);
	typedef void (*CBAddFriendCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMAddFriendCallback
	{
		CBAddFriendCallbackOnSuccess OnSuccess;
		CBAddFriendCallbackOnError OnError;
		void* data;
	}TIMAddFriendCallback;

	typedef void (*CBDelFriendCallbackOnSuccess) (TIMFriendResultHandle* handles, uint32_t num, void* data);
	typedef void (*CBDelFriendCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMDelFriendCallback
	{
		CBDelFriendCallbackOnSuccess OnSuccess;
		CBDelFriendCallbackOnError OnError;
		void* data;
	}TIMDelFriendCallback;

	typedef void (*CBFriendResponseCallbackOnSuccess) (TIMFriendResultHandle* handles, uint32_t num, void* data);
	typedef void (*CBFriendResponseCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMFriendResponseCallback
	{
		CBFriendResponseCallbackOnSuccess OnSuccess;
		CBFriendResponseCallbackOnError OnError;
		void* data;
	}TIMFriendResponseCallback; 

	typedef void (*CBGetFriendPendencyListCallbackOnSuccess) (TIMFriendPendencyMetaHandle meta, TIMFriendPendencyItemHandle* handles, uint32_t num, void* data);
	typedef void (*CBGetFriendPendencyListCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMGetFriendPendencyListCallback
	{
		CBGetFriendPendencyListCallbackOnSuccess OnSuccess;
		CBGetFriendPendencyListCallbackOnError OnError;
		void* data;
	}TIMGetFriendPendencyListCallback;
	
	typedef void(*CBGetFriendFurtureListCallbackOnSuccess) (TIMFriendFutureMetaHandle meta, TIMFriendFutureItemHandle* handles, uint32_t num, void* data);
	typedef void(*CBGetFriendFurtureListCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMGetFriendFurtureListCallback
	{
		CBGetFriendFurtureListCallbackOnSuccess OnSuccess;
		CBGetFriendFurtureListCallbackOnError OnError;
		void* data;
	}TIMGetFriendFurtureListCallback;

	typedef void(*CBDelPendencyFriendCallbackOnSuccess) (TIMFriendResultHandle* handles, uint32_t num, void* data);
	typedef void(*CBDelPendencyFriendCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMDelPendencyFriendCallback
	{
		CBDelPendencyFriendCallbackOnSuccess OnSuccess;
		CBDelPendencyFriendCallbackOnError OnError;
		void* data;
	}TIMDelPendencyFriendCallback;

	typedef void(*CBDelRecommendFriendCallbackOnSuccess) (TIMFriendResultHandle* handles, uint32_t num, void* data);
	typedef void(*CBDelRecommendFriendCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMDelRecommendFriendCallback
	{
		CBDelRecommendFriendCallbackOnSuccess OnSuccess;
		CBDelRecommendFriendCallbackOnError OnError;
		void* data;
	}TIMDelRecommendFriendCallback;

	typedef void(*CBDelDecideFriendCallbackOnSuccess) (TIMFriendResultHandle* handles, uint32_t num, void* data);
	typedef void(*CBDelDecideFriendCallbackOnError) (int code, const char* desc, void* data);
	typedef struct _T_TIMDelDecideFriendCallback
	{
		CBDelDecideFriendCallbackOnSuccess OnSuccess;
		CBDelDecideFriendCallbackOnError OnError;
		void* data;
	}TIMDelDecideFriendCallback;
	//interface
	TIM_DECL void TIMSetNickName(char* nick, uint32_t len, TIMCommCB * cb);
	TIM_DECL void TIMSetAllowType(E_TIMFriendAllowType type, TIMCommCB * cb);
	TIM_DECL void TIMSetFaceURL(char* url, uint32_t url_len, TIMCommCB * cb);
	TIM_DECL void TIMSetFriendRemark(const char* id, const char* remark, const uint32_t remark_len, TIMCommCB * cb);
	TIM_DECL void TIMGetSelfProfile(TIMGetSelfProfileCallback* cb);
	TIM_DECL void TIMGetFriendProfile(const char** id, uint32_t num, TIMGetFriendProfileCallback* cb);

	TIM_DECL void TIMSetPartialProfile(TIMSetProfileOptionHandle opt, TIMCommCB* cb);
	TIM_DECL void TIMGetPartialProfile(const char** id, uint32_t num, TIMGetProfileOptionHandle handle, TIMGetFriendProfileCallback* cb);


	// resp: sIdentifier, sNickname, sRemark
	TIM_DECL void TIMGetFriendList(TIMGetFriendListCallback * cb);
	
	// req: sIdentifier, sRemark, sAddWording, sAddSource
	// resp: sIdentifier, result
	TIM_DECL void TIMAddFriend(TIMAddFriendHandle* handles, uint32_t num, TIMAddFriendCallback * cb);
	// req: sIdentifier
	// resp: sIdentifier, result
	// TYPE: 1- 2-˫
	TIM_DECL void TIMDelFriend(int type, char** id, uint32_t num, TIMDelFriendCallback * cb);

	// req: sIdentifier, sResponse
	// resp: sIdentifier, result
	TIM_DECL void TIMFriendResponse(TIMFriendResponseHandle* handles, uint32_t num, TIMFriendResponseCallback * cb);

	// resp: sIdentifier, result
	TIM_DECL void TIMAddBlackList(const char** friends_id, uint32_t num, TIMFriendshipActionCB * cb);
	// resp: sIdentifier, result
	TIM_DECL void TIMDelBlackList(const char** friends_id, uint32_t num, TIMFriendshipActionCB * cb);
	// resp: sIdentifier
	TIM_DECL void TIMGetBlackList(TIMFriendshipActionCB * cb);

	// resp: sNickname
	TIM_DECL void TIMSearchUserUseIdentifier(char* id, TIMFriendshipActionCB * cb);

	/**
	*  ȡбҳԶȡֶΣ
	*
	*  @param flags Ҫȡֶ
	*  @param custom ԶֶΣĿǰ֧֣
	*  @param meta ԪϢTIMFriendMetaInfo˵
	*  @param cb   ص
	*/
	TIM_DECL void TIMGetFriendListV2(TIMProfileFlag flag, TIMProfileCustomInfoHandle custom, TIMFriendMetaInfoHandle meta, TIMGetFriendListV2Callback* cb);

	/**
	*  ͨȡδб
	*
	*  @param meta  ϢϸοTIMFriendPendencyMetaHandle
	*  @param type  ȡͣοTIMPendencyGetType
	*  @param cb   ص
	*/
	TIM_DECL void TIMGetPendencyFromServer(TIMFriendPendencyMetaHandle meta, TIMPendencyGetType type, TIMGetFriendPendencyListCallback* cb);

	/**
	*  δѶϱ
	*
	*  @param timestamp ѶʱʱǰϢΪѶ
	*  @param cb  ص
	*/
	TIM_DECL void TIMPendencyReport(uint64_t timestamp , TIMCommCB* cb);


	/**
	*  ƼѶϱ
	*
	*  @param timestamp ѶʱʱǰϢΪѶ
	*  @param cb  ص
	*/
	TIM_DECL void TIMRecommendReport(uint64_t timestamp, TIMCommCB* cb);

	/**
	*  δͺƼȡ
	*
	*  @param flags     ȡϱʶ
	*  @param type		ȡͣλ
	*  @param custom    ԶֶΣδʵ֣NULL
	*  @param meta      ϢμTIMFriendFutureMetaHandle
	*  @param cb  ص
	*/
	TIM_DECL void TIMGetFutureFriends(TIMProfileFlag flag, TIMFutureFriendType type, TIMProfileCustomInfoHandle custom_handle, TIMFriendFutureMetaHandle meta, TIMGetFriendFurtureListCallback* cb);


	/**
	*  δɾ
	*
	*  @param type  δ
	*  @param id	Ҫɾδб
	*  @param cb	ص
	*/
	TIM_DECL void TIMDeletePendency(TIMPendencyGetType type, const char** id, uint32_t num, TIMDelPendencyFriendCallback* cb);


	/**
	*  Ƽɾ
	*
	*  @param id	ҪɾƼб
	*  @param cb    ص
	*/
	TIM_DECL void TIMDeleteRecommend(const char** id, uint32_t num, TIMDelRecommendFriendCallback* cb);

	/**
	*  Ѿɾ
	*
	*  @param id	ҪɾѾб
	*  @param cb    ص
	*/
	TIM_DECL void TIMDeleteDecide(const char** id, uint32_t num, TIMDelDecideFriendCallback * cb);

}
#endif